/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.LineSlice;

import javax.swing.JFrame;
import javax.swing.WindowConstants;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.mappers.LineSlice.LineSliceShared.*;

public class LineSliceGUI extends javax.swing.JPanel
{

    protected Parameters parameters = null;

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public LineSliceGUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        axisGroup = new javax.swing.ButtonGroup();
        axisPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        iRadioButton = new org.visnow.vn.gui.swingwrappers.RadioButton();
        jRadioButton = new org.visnow.vn.gui.swingwrappers.RadioButton();
        kRadioButton = new org.visnow.vn.gui.swingwrappers.RadioButton();
        iPanel = new javax.swing.JPanel();
        iLabel = new javax.swing.JLabel();
        iSlider = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        jPanel = new javax.swing.JPanel();
        jLabel = new javax.swing.JLabel();
        jSlider = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        kPanel = new javax.swing.JPanel();
        kLabel = new javax.swing.JLabel();
        kSlider = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        recomputeMinMaxCB = new javax.swing.JCheckBox();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setBorder(javax.swing.BorderFactory.createEmptyBorder(4, 4, 4, 4));
        setLayout(new java.awt.GridBagLayout());

        axisPanel.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Line axis:"); // NOI18N
        axisPanel.add(jLabel2, new java.awt.GridBagConstraints());

        axisGroup.add(iRadioButton);
        iRadioButton.setSelected(true);
        iRadioButton.setText("i"); // NOI18N
        iRadioButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                axisChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        axisPanel.add(iRadioButton, gridBagConstraints);

        axisGroup.add(jRadioButton);
        jRadioButton.setText("j");
        jRadioButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                axisChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        axisPanel.add(jRadioButton, gridBagConstraints);

        axisGroup.add(kRadioButton);
        kRadioButton.setText("k"); // NOI18N
        kRadioButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                axisChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        axisPanel.add(kRadioButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        add(axisPanel, gridBagConstraints);

        iPanel.setLayout(new java.awt.BorderLayout());

        iLabel.setText("I:"); // NOI18N
        iLabel.setPreferredSize(new java.awt.Dimension(20, 50));
        iPanel.add(iLabel, java.awt.BorderLayout.WEST);

        iSlider.setVal(20);
        iSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                iSliderStateChanged(evt);
            }
        });
        iPanel.add(iSlider, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(iPanel, gridBagConstraints);

        jPanel.setLayout(new java.awt.BorderLayout());

        jLabel.setText("j:"); // NOI18N
        jLabel.setPreferredSize(new java.awt.Dimension(20, 50));
        jPanel.add(jLabel, java.awt.BorderLayout.WEST);

        jSlider.setVal(20);
        jSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                jSliderStateChanged(evt);
            }
        });
        jPanel.add(jSlider, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jPanel, gridBagConstraints);

        kPanel.setLayout(new java.awt.BorderLayout());

        kLabel.setText("k:"); // NOI18N
        kLabel.setPreferredSize(new java.awt.Dimension(20, 50));
        kPanel.add(kLabel, java.awt.BorderLayout.WEST);

        kSlider.setVal(20);
        kSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                kSliderStateChanged(evt);
            }
        });
        kPanel.add(kSlider, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(kPanel, gridBagConstraints);

        recomputeMinMaxCB.setText("recompute min/max"); // NOI18N
        recomputeMinMaxCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                recomputeMinMaxCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(recomputeMinMaxCB, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    void updateGUI(ParameterProxy p, final boolean resetRange)
    {
        int[] dims = p.get(META_FIELD_DIMENSION_LENGTHS);
        int[] values = new int[]{p.get(I_AXIS_VALUE), p.get(J_AXIS_VALUE), p.get(K_AXIS_VALUE)};
        kPanel.setVisible(dims.length > 2);
        kRadioButton.setVisible(dims.length > 2);
        iRadioButton.setSelected(p.get(SELECTED_AXIS) == Axis.I);
        jRadioButton.setSelected(p.get(SELECTED_AXIS) == Axis.J);
        kRadioButton.setSelected(p.get(SELECTED_AXIS) == Axis.K);

        updateSliderRange(dims, values, resetRange ? UpdateMode.RESET : UpdateMode.VALIDATE);

        iSlider.setVal(values[0]);
        jSlider.setVal(values[1]);
        if (dims.length > 2)
            kSlider.setVal(values[2]);

        updateSliderEnabledState();

        recomputeMinMaxCB.setSelected(p.get(RECALCULATE_MIN_MAX));
    }

    private void recomputeMinMaxCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_recomputeMinMaxCBActionPerformed
        parameters.set(RECALCULATE_MIN_MAX, recomputeMinMaxCB.isSelected());
    }//GEN-LAST:event_recomputeMinMaxCBActionPerformed

    private void axisChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_axisChangeAction
    {//GEN-HEADEREND:event_axisChangeAction
        updateSliderEnabledState();
        parameters.set(SELECTED_AXIS, iRadioButton.isSelected() ? Axis.I : jRadioButton.isSelected() ? Axis.J : Axis.K);
    }//GEN-LAST:event_axisChangeAction

    private void iSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_iSliderStateChanged
    {//GEN-HEADEREND:event_iSliderStateChanged
        parameters.set(I_AXIS_VALUE, iSlider.getVal(),
                       ADJUSTING, iSlider.isAdjusting());
    }//GEN-LAST:event_iSliderStateChanged

    private void jSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_jSliderStateChanged
    {//GEN-HEADEREND:event_jSliderStateChanged
        parameters.set(J_AXIS_VALUE, jSlider.getVal(),
                       ADJUSTING, jSlider.isAdjusting());
    }//GEN-LAST:event_jSliderStateChanged

    private void kSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_kSliderStateChanged
    {//GEN-HEADEREND:event_kSliderStateChanged
        parameters.set(K_AXIS_VALUE, kSlider.getVal(),
                       ADJUSTING, kSlider.isAdjusting());
    }//GEN-LAST:event_kSliderStateChanged

    private enum UpdateMode
    {
        VALIDATE, RESET
    }

    private void updateSliderRange(int[] dims, int values[], UpdateMode updateMode)
    {
        if (updateMode == UpdateMode.RESET || iSlider.getMax() > dims[0] - 1) iSlider.setMax(dims[0] - 1);
        if (updateMode == UpdateMode.RESET || jSlider.getMax() > dims[1] - 1) jSlider.setMax(dims[1] - 1);
        if (dims.length > 2)
            if (updateMode == UpdateMode.RESET || kSlider.getMax() > dims[2] - 1) kSlider.setMax(dims[2] - 1);

        if (iSlider.getMax() < values[0]) iSlider.setMax(values[0]);
        if (jSlider.getMax() < values[1]) jSlider.setMax(values[1]);
        if (dims.length > 2)
            if (kSlider.getMax() < values[2]) kSlider.setMax(values[2]);
    }

    private void updateSliderEnabledState()
    {
        iSlider.setEnabled(!iRadioButton.isSelected());
        jSlider.setEnabled(!jRadioButton.isSelected());
        kSlider.setEnabled(!kRadioButton.isSelected());
    }

    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup axisGroup;
    private javax.swing.JPanel axisPanel;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JLabel iLabel;
    private javax.swing.JPanel iPanel;
    private org.visnow.vn.gui.swingwrappers.RadioButton iRadioButton;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider iSlider;
    private javax.swing.JLabel jLabel;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel;
    private org.visnow.vn.gui.swingwrappers.RadioButton jRadioButton;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider jSlider;
    private javax.swing.JLabel kLabel;
    private javax.swing.JPanel kPanel;
    private org.visnow.vn.gui.swingwrappers.RadioButton kRadioButton;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider kSlider;
    private javax.swing.JCheckBox recomputeMinMaxCB;
    // End of variables declaration//GEN-END:variables
    public static void main(String[] args)
    {
        JFrame f = new JFrame();
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        final LineSliceGUI p = new LineSliceGUI();
        f.add(p);
        f.pack();
        f.setVisible(true);
    }
}
